Subject: Re: bug#41627: 28.0.50; Emacs with cairo build segfault in HELLO file

From: Zihao Zhu <[email-masked]>
Date: Sun, 31 May 2020 22:27:35 +0800

I think if font was not installed correctly, Emacs should display "tofu" 
for unsupported chars, but it will display it and segfault.

And I also found that Emacs can work well in ASCII and CJK only 
environment(Sarasa font). But segfault in HELLO file and any other 
multi-language buffer which Emacs will choose Noto family to display.

On 2020/5/31 下午8:35, Pip Cet wrote:
> On Sun, May 31, 2020 at 11:49 AM Zihao Zhu <[email-masked]> wrote:
>> I try the Emacs build in commit
>> 780f674a82a90c4e3e32583059b498bfa57e4a06. When I eval
>>
>> (set-frame-font "Sarasa Mono Slab SC" t)
>> GDB attached backtrace in attachment.
> This line seems suspicious:
>
>          font_face = 0x7ffff747e880 <_cairo_font_face_nil_file_not_found>
>
> It looks like you can't rely on cairo_ft_font_face_create_for_pattern
> to return a NULL pointer. I suspect the attached patch will work, but
> if this is something Cairo does in other places it needs to be
> checked.
>
> (My suspicion is the font was not installed correctly, so Cairo
> couldn't find it.)